/* SC68 ported to psl1ght by NoNameNo
   it can play .sc68 and .sndh file.
 */
#include <audio/audio.h>
#include <io/pad.h>
#include <psl1ght/lv2/timer.h>
#include <math.h>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "muz.bin.h"

#include "sc68src/api68/api68.h"
#include "sc68src/api68/mixer68.h"

#define PI 3.14159265f

api68_t * sc68 = 0;

u32 playOneBlock(u64 *readIndex, float *audioDataStart)
{
	signed short samples[256 * 2];
	static u32 audio_block_index=1;

	u64 current_block = *readIndex;

	if(audio_block_index == current_block)
	{
		return 0;
	}

	float *buf = audioDataStart + 2 /*channelcount*/ * AUDIO_BLOCK_SAMPLES * audio_block_index;
	api68_process(sc68, samples, 256 );
	for (int i = 0; i < 256 * 2; i++){
		buf[i] = (float)samples[i]/32767.0 ;
	}

	audio_block_index = (audio_block_index + 1) % AUDIO_BLOCK_8;

	return 1;
}

int main(int argc, const char* argv[])
{
	PadInfo padinfo;
        PadData paddata;

	api68_init_t init68;

	memset(&init68, 0, sizeof(init68));
    	init68.alloc = malloc;
    	init68.free = free;

    	sc68 = api68_init(&init68);
    	api68_load_mem(sc68, muz_bin, sizeof(muz_bin));
    	api68_play(sc68, 1, 0);

	AudioPortParam params;
	AudioPortConfig config;
	u32 portNum;

	ioPadInit(7);
	ioPadGetData(0, &paddata);

	audioInit();
	params.numChannels = AUDIO_PORT_2CH;
	params.numBlocks = AUDIO_BLOCK_8;
	params.attr = 0;
	params.level = 0.5f;

	audioPortOpen(&params, &portNum);
	audioGetPortConfig(portNum, &config);
	audioPortStart(portNum);

	while(paddata.BTN_CROSS==0)
	{
		ioPadGetData(0, &paddata);

		playOneBlock((u64*)(u64)config.readIndex,(float*)(u64)config.audioDataStart);
	}

	audioPortStop(portNum);
	audioPortClose(portNum);
	audioQuit();

	return 0;
}
